/********************************************
 * globals.h                                *
 * Global enums to make code easier to read *
 ********************************************/


 enum displayOptions
 {
    ATARI_SMALL,
    ALTERNATE_SMALL,
    ALTERNATE_LARGE
 };


 enum gameStates
 {
    EXPLORE = 1,
    MODULE = 2,
    ENCOUNTER = 3,
    DEAD = 4
 };


 enum selectStates
 {
     USE = 1,
     DROP = 2,
     OFFER = 3,
     DEPOSIT = 4,
     WITHDRAWAL = 5
 };


 enum scenarios
 {
     CITY,
     DUNGEON,
     ARENA,
     PALACE,
     WILDERNESS,
     REVELATION,
     DESTINY
 };

 enum directions
 {
     NONE,
     WEST,
     NORTH,
     EAST,
     SOUTH
 };

 enum modules
 {
     RATHSKELLER = 0x1D
 };

 enum encounters
{   DEVOURER = 0,
	THIEF = 1,
	ASSASSIN = 2,
	GOBLIN = 3,
	TROLL = 4,
	LICH = 5,
	UNDEAD_KNIGHT = 6,
	GUARD = 7,
	FBI_AGENT = 8,
	DARK_KNIGHT = 9,
	CHAMPION = 10,
	HEALER = 11,
	KNIGHT = 12,
	PAUPER = 13,
	NOBLEMAN = 14,
	ALIEN_SENTRY = 15,
	ROBOT = 16,
	NOVICE = 17,
	APPRENTICE = 18,
	MAGE = 19,
	WIZARD = 20,
	ACOLYTE = 21,
	SAGE = 22,
	ORC = 23,
	GNOME = 24,
	DWARF = 25,
	SLIME = 26,
	MOLD = 27,
	HOMUNCULUS = 28,
	PHOENIX = 29,
	SORCERESS = 30,
	WHIRLWIND = 31,
	GIANT_RAT = 32,
	SMALL_DRAGON = 33,
	SKELETON = 34,
	ZOMBIE = 35,
	GHOUL = 36,
	GHOST = 37,
	SPECTRE = 38,
	WRAITH = 39,
	VAMPIRE = 40,
	GREAT_BAT = 41,
	HELLHOUND = 42,
	HARPY = 43,
	GREMLIN = 44,
	IMP = 45,
	FLAME_DEMON = 46,
	STORM_DEVIL = 47,
	GIANT_WOLF = 48,
	WEREWOLF = 49,
	WARRIOR = 50,
	WEAPONMASTER = 51,
	VALKYRIE = 52,
	GLADIATOR = 53,
	MERCENARY = 54,
	DOPPLEGANGER = 55,
	ADVENTURER = 56,
	WATERSPRITE = 57,
	NIGHTSTALKER = 58,
	SALAMANDER = 59,
	RONIN = 60,
	SERPENTMAN = 61,
	BIG_SNAKE = 62,
	GREAT_NAGA = 63,
	BERSERKER = 64,
	BASILISK = 65,
	GREAT_WYRM = 66,
	GOBLIN_LORD = 67,
	TROLL_TYRANT = 68,
	ICE_DEMON = 69,
	HORNED_DEVIL = 70,
	MUGGER = 71, // City only from here
	ROBBER = 72,
	FIGHTER = 73,
	SWORDSMAN = 74,
	COURIER = 75,
	COMMONER = 76,
	MERCHANT = 77,
	ARCHMAGE = 78,
	GNOLL = 79,
	HOBBIT = 80,
	GIANT = 81,
	SMALL_GREEN_DRAGON = 82,
	NOBLEWOMAN = 83
};

 // Add encounters

 // Add items
