
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

#include "player.h"
#include "font.h"
#include "display.h"
#include "game.h"
#include "encounter.h"
#include "misc.h"
#include "smithy.h"
#include "items.h"
#include "lyrics.h"
#include "actor.h" // For weapons

using namespace std;

extern buffer_item itemBuffer[100];

extern sf::Clock        clock1;
extern int              iCounter;

sf::Music smithyMusic;

int itemChoice;
int itemNo, itemCost;
int menuStartItem;
int maxMenuItems = 6;
int smithyNo;

struct Smithy
{
   string name;
   float minimumPriceFactor;
   float initialPriceFactor;
   int location; // match with location text description number
   int openingHour;
   int closingHour;
};

Smithy Smithies[4] =
{
	{"Sharp Weaponsmiths",		1.25,		1.65,	55,		4,	20},
	{"Occum's Weaponsmiths",	1.10,		1.35,	56,		5,	21},
	{"Best Armorers",			1.50,		2.40,	57,		8,	19},
	{"Knight's Armorers",		1.60,		2.35,	58,		11,	15}

};

bool smithyWaresCheck[4][23]; // markers used to check for duplicate items

extern int smithyDailyWares[4][10];

struct smithyItem
{

	string name;
	int type; // 177 - armour, 178 - weapon
	int basePrice;
	int itemRef;
};

smithyItem smithyWares[23] =
{
	{"a Stiletto",		178,113,	61},
	{"a Dagger",		178,129,	62},
	{"a Whip",			178,396,	63},
	{"a War Net",		178,908,	57},
	{"Padded Armor",	177,2200,	1},
	{"a Small Shield",	178,2460,	60},
	{"a Shortsword",	178,3146,	64},
	{"a Shield",		178,4290,	59},
	{"a Flail",			178,4620,	65},
	{"Leather Armor",	177,4840,	2},
	{"a Spiked Shield",	178,6160,	58},
	{"a Battle Axe",	178,16930,	66},
	{"Studded Armor",	177,7260,	3},
	{"a Sword",			178,7680,	67},
	{"a Tower Shield",	178,9488,	56},
	{"Ring Mail",		177,10010,	4},
	{"a Battle Hammer",	178,10285,	68},
	{"a Longsword",		178,11193,	69},
	{"Scale Mail",		177,14245,	5},
	{"Splint Mail",		177,18975,	6},
	{"Chain Mail",		177,24640,	7},
	{"Banded Armor",	177,32000,	8},
	{"Plate Armor",		177,41500,	9}
};




void shopSmithy()
{
	if (plyr.timeOfDay == 1) { loadShopImage(8); } else { loadShopImage(9); }

	int offerStatus = 0; // 0 is normal, 1 is demanding, 2 is bartering
	int offerRounds = 0;
	int  itemLowestCost, smithyOffer;

	if (plyr.timeOfDay == 1) { loadShopImage(8); } else { loadShopImage(9); }

	smithyNo = getSmithyNo();
	bool musicPlaying = false;
	int smithyMenu = 1; // high level menu
	string str,key;
	plyr.status = 2; // shopping
	menuStartItem = 0; // menu starts at item 0
	if ((Smithies[smithyNo].closingHour<=plyr.hours) || (Smithies[smithyNo].openingHour>plyr.hours)) {smithyMenu = 5;}


	while (smithyMenu > 0)
	{
		while (smithyMenu == 5) // closed
		{
			smithyDisplayUpdate();
			cyText (1, "Sorry, we are closed. Come back@during our working hours.");
			str = "We are open from " + itos(Smithies[smithyNo].openingHour) + ":00 in the morning@to " + itos(Smithies[smithyNo].closingHour) + ":00 in the evening.";
			if (Smithies[smithyNo].closingHour == 15) { str = "We are open from " + itos(Smithies[smithyNo].openingHour) + ":00 in the morning@to " + itos(Smithies[smithyNo].closingHour) + ":00 in the afternoon."; }
			cyText (4, str);
			cyText (9,"( Press a key )");
			updateDisplay();

			key = getSingleKey();
			if ((key!="") && (key!="up")) { smithyMenu = 0; }

		}

		while (smithyMenu == 1) // main menu
		{
			smithyDisplayUpdate();
			bText (13,0, "Welcome Stranger!");
			bText (7,3, "Do you wish to see our wares?");
			cyText (5, "( es or  o)");
			SetFontColour(40, 96, 244, 255);
			cyText (5, " Y      N  ");
			SetFontColour(215, 215, 215, 255);
			displayCoins();
			updateDisplay();

			if (!musicPlaying)
			{
				//int Random = randn(0, 2);
				if (plyr.musicStyle==0)
				{ smithyMusic.openFromFile("data/audio/armor.ogg"); }
				else
				{ smithyMusic.openFromFile("data/audio/B/armor.ogg"); }
				loadLyrics("armor.txt");
				smithyMusic.play();
				musicPlaying = true;
			}


			key = getSingleKey();
			if ( key=="Y" ) { smithyMenu = 2; }
			if ( key=="N" ) { smithyMenu = 0; }
			if ( key=="down" ) { smithyMenu = 0; }
		}

		while (smithyMenu == 2)
		{
			offerStatus = 0;
			offerRounds = 0;
			smithyDisplayUpdate();
			cyText (0, "What would you like? (  to leave)");
			SetFontColour(40, 96, 244, 255);
			cyText (0, "                      0          ");
			SetFontColour(215, 215, 215, 255);

			smithyNo = getSmithyNo();
			for (int i=0 ; i<maxMenuItems ; i++)
			{
				int itemNo = smithyDailyWares[smithyNo][menuStartItem+i];
				str = ") " + smithyWares[itemNo].name;
				if ((smithyWares[itemNo].itemRef) > 10)
				{ str = ") " + Weapons[smithyWares[itemNo].itemRef].name; }
				bText(3,(2+i), str); //was 4
				bText(1,(2+i), "                                 coppers");
			}
			displayCoins();

			int itemCost, x;
			for (int i=0 ; i<maxMenuItems ; i++) // Max number of item prices in this menu display
			{
				string itemCostDesc;
				x = 28;
				int itemNo = smithyDailyWares[smithyNo][menuStartItem+i];
				itemCost = Smithies[smithyNo].initialPriceFactor * smithyWares[itemNo].basePrice;
				//itemCost = smithyWares[itemNo].basePrice;
				if (itemCost<1000) { x = 30;}
				if (itemCost>999) { x = 28;}
				if (itemCost>9999) { x = 27;}
				itemCostDesc = toCurrency(itemCost);
				bText (x,(i+2),itemCostDesc);
			}

			SetFontColour(40, 96, 244, 255);
			bText (2,2, "1");
			bText (2,3, "2");
			bText (2,4, "3");
			bText (2,5, "4");
			bText (2,6, "5");
			bText (2,7, "6");
			if (menuStartItem!=0) { bText (2,1, "}"); }
			if (menuStartItem!=4) { bText (2,8, "{"); }
			SetFontColour(215, 215, 215, 255);

			updateDisplay();

			key = getSingleKey();
			if ( key=="1" ) { itemChoice = 0; smithyMenu = 20; }
			if ( key=="2" ) { itemChoice = 1; smithyMenu = 20; }
			if ( key=="3" ) { itemChoice = 2; smithyMenu = 20; }
			if ( key=="4" ) { itemChoice = 3; smithyMenu = 20; }
			if ( key=="5" ) { itemChoice = 4; smithyMenu = 20; }
			if ( key=="6" ) { itemChoice = 5; smithyMenu = 20; }
			if ( (key=="up") && (menuStartItem>0) ) { menuStartItem--; }
			if ( (key=="down") && (menuStartItem<4) ) { menuStartItem++; }
			if ( key=="ESC" ) { smithyMenu = 0; }
			if ( key=="0" ) { smithyMenu = 0; }

		}


		while (smithyMenu == 20) // buy item?
		{
			smithyNo = getSmithyNo();
			itemNo = smithyDailyWares[smithyNo][menuStartItem+itemChoice];
			itemCost = Smithies[smithyNo].initialPriceFactor * smithyWares[itemNo].basePrice;
			float tempitemcost = Smithies[smithyNo].initialPriceFactor * smithyWares[itemNo].basePrice;
			float temp = (tempitemcost/100)*75;
			itemLowestCost = temp;
			smithyOffer = itemCost;
			smithyMenu = 3;
		}



		while (smithyMenu == 3) // buy item
		{

			smithyDisplayUpdate();
			if (offerStatus==0)
			{
				str = "The cost for " + smithyWares[itemNo].name;
				cyText (0,str);
				str = "is " + toCurrency(smithyOffer) + " coppers. Agreed?";
				cyText (1,str);
			}
			if (offerStatus==1)
			{
				str = "I demand at least " + toCurrency(smithyOffer) + " silvers!";
				cyText (1,str);
			}
			if (offerStatus==2)
			{
				str = "Would you consider " + toCurrency(smithyOffer) + "?";
				cyText (1,str);
			}

			bText (11,3," ) Agree to price");
			bText (11,4," ) Make an offer");
			bText (11,5," ) No sale");
			bText (11,6," ) Leave");
			displayCoins();
			SetFontColour(40, 96, 244, 255);
			bText (11,3,"1");
			bText (11,4,"2");
			bText (11,5,"3");
			bText (11,6,"0");
			SetFontColour(215, 215, 215, 255);

			updateDisplay();

			key = getSingleKey();
			if ( key=="1" )
			{

				if (!checkCoins(0,0,smithyOffer)) { smithyMenu = 5; } // offended!
				else { smithyMenu = 4; }
			}

			if ( key=="2" ) { smithyMenu = 16; }
			if ( key=="3" ) { smithyMenu = 2; }
			if ( key=="0" ) { smithyMenu = 0; }

		}


		while (smithyMenu == 16) // what is your offer
		{
			int coppers = inputValue("What is your offer? (in coppers)",9);

			// check offer
			if ( coppers==0 ) { smithyMenu = 2; }

			if ( coppers >= itemCost )
			{
				smithyOffer = coppers; // accepted the players offer
				offerStatus = 2;
				smithyMenu = 20;
			}
			if (( coppers >= itemLowestCost ) && ( coppers < itemCost ))
			{

				offerStatus = 2;
				offerRounds++;
				if ( offerRounds > 2 ) { smithyOffer = coppers; smithyMenu = 20; }
				else
				{
					smithyOffer = randn(coppers,itemCost);
					itemLowestCost = coppers;
					smithyMenu = 3;
				}
			}
			if (( coppers < itemLowestCost ) && (coppers > 0))
			{
				offerStatus=1;
				offerRounds++;
				smithyOffer = itemLowestCost;
				if ( offerRounds > 1 ) { smithyMenu = 19; }
				else	{ smithyMenu = 3; }
			}
		}




		while (smithyMenu == 20) // Offer accepted (subject to funds check)
		{
			smithyDisplayUpdate();
			cText ("Agreed!");
			updateDisplay();
			key = getSingleKey();

			if ( key!="" )
			{
				if (!checkCoins(0,0,smithyOffer)) { smithyMenu = 5; }
				else {  plyr.smithyFriendships[smithyNo]++; if (plyr.smithyFriendships[smithyNo] > 4) { plyr.smithyFriendships[smithyNo] = 4; } smithyMenu = 4; }
			}
		}

		while (smithyMenu == 19) // Leave my shop
		{
			smithyDisplayUpdate();
			cText ("Leave my shoppe and don't return@@until you are ready to make a decent@@offer!");
			updateDisplay();
			key = getSingleKey();

			if ( key!="" ) { plyr.smithyFriendships[smithyNo]--; if (plyr.smithyFriendships[smithyNo] < 0) { plyr.smithyFriendships[smithyNo] = 0; } smithyMenu = 0; } // Thrown out
		}



		while (smithyMenu == 5) // insufficient funds!
		{
			smithyDisplayUpdate();
			cText ("THAT OFFENDS ME DEEPLY!@Why don't you get serious and only@agree to something that you can afford!");
			cyText (9,"( Press a key )");
			updateDisplay();
			key = getSingleKey();

			if ( key!="" ) { smithyMenu = 2; } // back to purchases
		}

		while (smithyMenu == 4) // Agree to buy item and have funds
		{
			smithyDisplayUpdate();
			cText ("An excellent choice!");
			cyText (9,"( Press a key )");
			updateDisplay();
			key = getSingleKey();


			if ( key!="" )

			{
				// Add a weight & inventory limit check prior to taking money
				deductCoins(0,0,smithyOffer);
				int objectNumber = smithyWares[itemNo].itemRef; // ref within Weapons array
				//int weaponNumber = smithyWares[itemNo].itemRef; // ref within Weapons array
				if (objectNumber>10)
				{
					// Weapon item
					int itemHandle = createWeapon(objectNumber); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==1)
				{
					// Padded armor set - buying group of items
					int itemHandle = createArmor(0); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(1); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(2); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(3); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==2)
				{
					// Leather armor set - buying group of items
					int itemHandle = createArmor(4); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(5); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(6); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(7); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==3)
				{
					// Studded armor set - buying group of items
					int itemHandle = createArmor(8); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(9); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(10); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(11); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==4)
				{
					// Ring mail set - buying group of items
					int itemHandle = createArmor(12); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(13); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(14); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==5)
				{
					// Scale mail set - buying group of items
					int itemHandle = createArmor(15); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(16); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(17); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==6)
				{
					// Splint mail set - buying group of items
					int itemHandle = createArmor(18); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(19); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(20); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==7)
				{
					// Chain mail set - buying group of items
					int itemHandle = createArmor(24); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(25); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(26); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==8)
				{
					// Banded mail set - buying group of items
					int itemHandle = createArmor(27); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(28); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(29); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(30); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}
				if (objectNumber==9)
				{
					// Plate mail set - buying group of items
					int itemHandle = createArmor(35); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(36); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(37); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
					itemHandle = createArmor(38); // create a new weapon or armour item(s)
					itemBuffer[itemHandle].location = 10; // Add to player inventory - 10
				}

				smithyMenu = 2; // back to purchases
			}

		}


	}
	smithyMusic.stop();
	leaveShop();
}




int getSmithyNo()
{
	int smithy_no;
	for (int i=0 ; i<4 ; i++) // Max number of smithy objects
	{
		if (Smithies[i].location == plyr.location)
		{
				smithy_no = i; // The number of the smithy you have entered
		}
	}
	return smithy_no;
}


void stockSmithyWares()
{
	// Run each day to randomly pick 10 items for sale at each of the 4 smithies
	// Check for duplicates using smithyWaresCheck array of bools

	// Set bools for duplicate items check to false
	int itemNo = 0;

	for (int x=0; x<4; x++)
	{
		for (int y=0; y<23; y++)
		{
			smithyWaresCheck[x][y] = false;
		}
	}

	for (int smithyNo=0 ; smithyNo<4 ; smithyNo++)
	{
		for (int waresNo=0 ; waresNo<10 ; waresNo++)
		{
			// Current code may create duplicate items in each smithy
			bool uniqueItem = false;
			while (!uniqueItem)
			{
				itemNo = randn(0,22);

				if (!smithyWaresCheck[smithyNo][itemNo])
				{
					smithyDailyWares[smithyNo][waresNo] = itemNo; // its not a duplicate
					smithyWaresCheck[smithyNo][itemNo] = true;
					uniqueItem = true;
				}
			}
		}
	}

	// Simple sort of items in numeric order
    sort(smithyDailyWares[0], smithyDailyWares[0]+10);
	sort(smithyDailyWares[1], smithyDailyWares[1]+10);
	sort(smithyDailyWares[2], smithyDailyWares[2]+10);
	sort(smithyDailyWares[3], smithyDailyWares[3]+10);

	// Always make sure a stiletto will be available
	smithyDailyWares[0][0] = 0;
	smithyDailyWares[1][0] = 0;
	smithyDailyWares[2][0] = 0;
	smithyDailyWares[3][0] = 0;
}


void smithyDisplayUpdate()
{
    clock1.restart();
	clearShopDisplay();
	updateLyrics();
	iCounter++;
}
